/*
  Copyright 2005 Damien Stehlé.

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along
  with this program; see the file COPYING.  If not, write to the Free
  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.

  This program implements ideas from the paper "Gal's Accurate Tables Method 
  Revisited", by Damien Stehlé and Paul Zimmermann, in the Proceedings of 
  Arith'17, IEEE.

*/


int Degree (mpz_t *, int);
void Res22 (mpz_t *, mpz_t *, mpz_t *, mpz_t *, mpz_t);
void set_matrix (mat_ZZ *, mpz_t, mpz_t, mpz_t, mpz_t, mpz_t, mpz_t, 
		 mpz_t, mpz_t);
void Norm1 (mpz_t, mpz_t *);
void get_lin_coeffs (mpz_t *, mpz_t, mpz_t, mpz_t, mpz_t, mpz_t, 
                     mpz_t, mpz_t);
void centermod (mpz_t *, int, mpz_t);
int slz (mpz_t *, mpfr_t *, mpfr_t *, mpz_t, mpz_t, mpz_t, mat_ZZ *);
int Check (mpz_t *, int, mpz_t, int, int, mpfr_t);


